# Hyperparameter Optimization on CERN grid with PANDA 

This document contains instruction to perform a hyperparameter optimization using HPOGUI web application. I will walk you through the steps from writing your training script to obtaining the final result. 

For this tutorial, I have created a simple convolutional neural network model to identify traffic signs. The training script is located [here](train_script/traffic_sign_cnn.py).

## General requirements
A hyperparameter optimization job takes in 3 main ingredients:
<ol>
<li> A training script to be executed inside a container.
<li> An input.json file containing the hyperparameter point to evaluate.
<li> Input data. 
</ol>
We will go over each of these ingredients in the following sections. 

## Step 1: Creating your training script.
Your training script must meet several requirements to run on the grid.  The script I am using takes in 2 things as input:
<ol>
<li>Train, validation and test datasets. For this tutorial, these datasets are downloaded from an online source.
<li>An "input.json" file which contains the hyperparameter point at which we evaluate the loss. 
</ol>
You can test this training script by 

```
git clone https://gitlab.cern.ch/tupham/traffic-sign-cnn.git -b master
cd traffic-sign-cnn
virtualenv env --python=python3.8
source env/bin/activate
pip install -r requirements.txt
pip install tensorflow

python train_script/traffic_sign_cnn.py example_config/input.json
```

If everything goes well, the script exits after saving an output.json file containing the loss, e.g.

```
{"loss": 7.238796516231195, "accuracy": 0.8948535233570863}
```

In general, a training script must be able to to do 3 things:
<ol>
<li> Read training data and hyperparameter input.
<li> Train.
<li> Output the loss as a json file, called output.json.
</ol>
<p>
For the sake of simplicity, this training script downloads the training data from a server, so there is no need to prepare and upload the data to rucio. However, it is important that the training script imports the hyperparameter point from an external <i>input.json</i> file, because PANDA serves the hyperparameter point in this manner.
</p>
<p>
After training, it is also important that an <i>output.json</i> is generated in the format:

```
{"loss": LOSS_VALUE}
```
the loss must be included in the output. You can output other metrics as well, but PANDA will look for the loss in your output.json. If it cannot find it, your task will fail.
</p>
Other than these requirements, your training script can be anything you like. 

## Step 2: The input.json file
My input.json is located in [example_config/input.json](example_config/input.json). It simply contains the hyperparameters you want to use in the script in the form 

```
{
    "hyperparameter_1": value_1,
    "hyperparameter_1": value_2,
    ...
}
```
For example, my file reads

```
{
    "learning_rate": "0.01",
    "epochs": 1.0,
    "log2_batch_size": 5,
    "log10_momentum": 1
}
```
In practice, the input.json file is generated by PANDA and supplied to your container. Even though you won't be able to directly control this process, you can configure your task so that PANDA generates the input hyperparameter in this exact format. More on this later. At this step, it is important to make sure your script can run locally with a given input file.

## Step 3: Containerize your module
Now that we have the main ingredients (primarily the training script) ready, we want to put them into a box that PANDA can quickly open and run without any additional installation. For this we use Docker and Gitlab Continuous Integration (CI).

If you are not familiar with Docker images, they are prepackaged and ready-to-ship "boxes" which contain our payload (scripts, input, etc.) capable of running on any platform. We will create an image that has our script, our input.json file, and the requirements.txt files to install necessary packages. 

If you don't have Docker on your local machine, install Docker and Docker CLI by following [this link](https://docs.docker.com/get-docker/). If you are completely new to Docker, some good overview and tutorial may be found [here](https://docs.docker.com/get-started/). I recommend going through the video in the "Getting started" section to understand the concepts we are dealing with.

In your repository, create a Dockerfile by 
```
touch Dockerfile
```
and add to it the following commands. I will explain what each line does, so you can modify them to meet your needs.
```
FROM [BASE IMAGE]
```
Our goal is to create a Docker image that contains our code. We build this image on some base image that contains as many predefined packages as we want. For example, in my Dockerfile, I have
```
FROM tensorflow/tensorflow:latest
```
because I use tensorflow to construct my neural network model. "tensorflow/tensorflow:latest" is itself an image preinstalled with tensorflow. You can go to [Docker Hub](https://hub.docker.com/) to find a base image that fits your bill. If you don't know which image to use, get a generic one, such as [python 3.8.12](https://hub.docker.com/layers/python/library/python/3.8.12/images/sha256-814defa8b532856c70d5588220d19b2d7090a9df845b263345730252a0a049fc?context=explore). In addition, the machine learning group provides several base images installed with the most common packages for machine learning (scikit-learn, pandas, tensorflow, etc.). You and find these images at [this registry](https://gitlab.cern.ch/tupham/ci-docker/container_registry).


At the beginning of the build process, the base image is pulled from Dockerhub and then built upon with subsequent Dockerfile instructions, each making some changes and committing to the base image. 

```
ARG PROJECT=ATLASMOHPO
```
defines a variable that you can pass at build-time. 
```
RUN mkdir ${PROJECT}
RUN apt-get update 
RUN apt-get install -y --no-install-recommends git wget unzip bzip2 build-essential ca-certificates graphviz vim
RUN apt-get clean
RUN pip install --upgrade pip
```
The "RUN" instruction executes any commands in on top of the current image and commit the results. E.g. The first command creates a directory called "ATLASMLHPO" in the root directory of the image. The next three commands install some necessary tools.
```
COPY ./train_script ${PROJECT}/train_script
COPY ./example_config ${PROJECT}/example_config
COPY ./requirements.txt ${PROJECT}/requirements.txt
```
Each of these commands copies a file in the <b>external</b> file system into the image. E.g. the first instruction copies the whole train_script and puts it under ${PROJECT}, etc.
```
RUN pip install -r ${PROJECT}/requirements.txt
```
This is the place where you install the packages necessary to your training script. My requirements.txt contains
```
numpy
pyyaml
scikit-learn
wget
```
without tensorflow because the base image already comes with this package. If your base image is generic, you may want to list all packages in your requirements.txt.

This is the minimal configuration I need to build my image. You might want to include additional features that meet your need, in which case you can find instructions in this [Dockerfile reference](https://docs.docker.com/engine/reference/builder/). Now it's time to build and test run. To start building, do
```
docker build -t [some-image-name]:[some-image-tag] .
```
The first time you build it will take some time to pull the base image. Once it's done, you can check the resulting image by 
```
docker images
```
You can run an interactive container from the image by 
```
docker run -it --rm [some-image-name]:[some-image-tag] "/bin/bash"
```
Now you are on the command line inside the container. Make sure you have a directory with the same name you assign to $PROJECT in the root directory. In my container, I can test run my training script by calling 
```
python train_script/traffic_sign_cnn.py example_config/input.json
```
The script should save an output.json file in the root folder before exiting. If I see this, I know my container works. Remember, you won't be able to monitor the script while it is running, so it is important to do test run. 

## Step 4: Build Docker image using Gitlab-CI
In theory, your docker image is ready for use. You could push it to your Dockerhub account and pull it from anywhere. However, it is likely that you store your code in Gitlab, so it is convenient to let gitlab build and store the image as well. Additionally, everytime you push a new commit to gitlab, it automatically builds the new image containing the updated code, so you won't have to worry about initiating the build process manually. To start, create a .gitlab-ci.yml at the root folder of your repository with the following content
```
build traffic-sign-cnn-image:
  image:
    name: gitlab-registry.cern.ch/ci-tools/docker-image-builder
    entrypoint: [""]
  stage: build
  variables:
    GIT_SUBMODULE_STRATEGY: recursive
  script:
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > /kaniko/.docker/config.json
    - /kaniko/executor --context $CI_PROJECT_DIR --dockerfile $CI_PROJECT_DIR/Dockerfile --destination $CI_REGISTRY_IMAGE:[SOME TAG NAME]
```
This file tells Gitlab that every time you push your code to git, it builds a new image for you and saves it to your container registry. It does so with a tool called kaniko, by running inside [this container](gitlab-registry.cern.ch/ci-tools/docker-image-builder), which is define under "image". 

The only thing you might want to change is the tag name of the resulting image. Once everything looks correct, commit, push to git and watch the magic happen!

## Step 5: Test your Gitlab-generated image
Once the build job is done (or fail, in which case you need to check the build log to see what's wrong), you can find your image by navigating to "Packages & Registries" -> "Container Registry" on the left panel. You should see your root image. Click on it and copy the link to your tag. 

On your local machine, pull the image and run using Docker; my version is
```
docker run -it --rm gitlab-registry.cern.ch/tupham/traffic-sign-cnn:traffic-sign-cnn "/bin/bash -c \"python ATLASMLHPO/train_script/traffic_sign_cnn.py ATLASMLHPO/example_config/input.json\" "
```
Then you should run your training script as we tested in step 3. If it can successfully run, you evaluation container is ready for deployment on the grid. 

<!-- ## Step 6: Preparing your data
This is where we deal with the complication described at the beginning of Step 1, i.e. if you want PANDA to serve the directly data to your container, which is particularly useful when your data is accessible by rucio. This section shows how to upload your data to rucio for this purpose. 

I'll repurpose my data set so that it acts like a  -->

## Step 6: Configure your task 
The ingredients of a task submission include:
<ol>
<li> Authentication and an id token from PANDA server
Open (https://hpo-dash-app.herokuapp.com/submission)[https://hpo-dash-app.herokuapp.com/submission] and click on Sign in if you haven't signed in before. The right panel will open with a link to authenticate using your CERN SSO credentials.

![Sign-in screen](images/sign-in.png)

Click on the button and select "CERN SSO" in the newly opened tab. 

![Sign-in screen](images/sign-in-screen.png)

After signing in, you should see a screen like this:

![Authenticate screen](images/authenticate.png)

Click on "Authorize", wait to finish, and return to HPOGUI. When you see the loading screen has stopped, refresh the page. If the authentication was successful, you should see your CERN username on the navbar, like this:

![Authenticated screen](images/authenticated.png)

Otherwise, redo the authentication.
<li>A search space
<p> The set of hyperparameter points over which we wish to optimize our model is called the search space. Each hyperparameter in the search space has a predefined set of possible values and a sampling method which selects from this set a particular value to evaluate. There are two available methods: (1) the categorical method, which randomly selects from a list of values, and (2) the uniform method which samples a uniform distribution bounded by two boundaries. </p>
<p> You can define the search space by following the syntax in this <a href='https://panda-wms.readthedocs.io/en/latest/client/phpo.html'>page</a>. However HPOGUI provides an easier way to configure the search space. Go to <a href='https://hpo-dash-app.herokuapp.com/submission'>https://hpo-dash-app.herokuapp.com/submission</a> and select the search space tab. You will see the following interface

![Search space interface](/images/search-space.png)


Follow these steps:
<ol type="a">
<li> Type the the first hyperparameter name and click on the button at the end of the input field.
<li> Select a sampling method.
<li> Fill out the fields required for your method. If you select the categorical method, enter a comma-separated list of categories. If you select uniform, enter the appropriate lower and upper bounds of the uniform distribution.
</ol>
Repeat from step (a) to add more hyperparameters. To remove any hyperpararmeter, click on the corresponding Remove button. At the end, my search space tab looks like this

![Completed search space interface](/images/completed-search-space.png)

Note that:
<ol type='i'>
<li> The sampling method for "learning_rate" is categorical, and the categories are ["0.01", "0.02", "0.05", "0.1", "0.2", "0.001", "0.005"]. The output of categorical sampling is always a string. Therefore, the learning rate must be converted to float in the training script before use.
<li> The hyperparameter "epochs" is uniformly sampled from 5-30. To obtain a integer value, I convert it by using np.ceil() in the training script.
<li> Instead of uniformly sampling the batch_size, I uniformly sample its base 2 logarithm, because the batch_size is some power of 2, such as 32, 64, 128, 356, etc. In the training script, I convert "log2_batch_size" to the batch_size by $` batch_size = 2^{np.ceil(log2BatchSize)} `$.
<li> Finally, the base 10 logarithm of the momentum $` \beta `$ is uniformly sampled and converted back in the training script by $` \beta = 10^{-\mathrm{log10Momentum}} `$
</ol>
<p>These conversions are done in the following lines.</p>

```
params['learning_rate'] = float(params['learning_rate'])
params['epochs'] = int(np.ceil(params['epochs']))
params['batch_size'] = int(2 ** (np.floor(params['log2_batch_size'])))
params['momentum'] = 1 - 10**( - (params['log10_momentum']))
```

<p>As you can see, a few simple manipulations within the training script can convert the outcome of the simple uniform distribution that HPOGUI provides into that of any sampling distribution. This simplifies the sampling methods in the submission process and leaves the flexibity to convert into different distribution to you. </p>
<li>Task configuration
<p> The task configuration controls how your task is carried out on PANDA. HPOGUI provides an interface to configure your task. After adding your search space, click on Next or the Task Configuration tab to open this interface. </p>

![Task configuration interface](/images/configurations.png)

<p> Many of the configurations are set to default values, which are sufficient to run most tasks. To effectively configure a task, some understading of how things work under the hood is needed. </p>

<p>There are two components working together to run your task: a steering process and an evaluation process. Hyperparameter points are generated and evaluated in successive iterations. At each iteration, the steering process generatea a number of hyperparameter points and passes them to evaluation process. The latter creates jobs run your training script, which evaluates the loss at these points. As mentioned in step 1, your training script must recognize an input file containing the new HP, whose name you specify in the configuration and output a file containing the loss value, whose name must also be provided. You can use any "lossy" quantity as the loss, e.g. test loss, test error, etc. In addition, your training script might also output another file, whose name must be provided, containing additional metrics you might use to evaluate the entire optimization task. </p>

<p>The following configurations control these processes:

<ul>
<li> Number of parallel evaluations: The number of evaluation jobs that can be run concurrently.
<li> Max number of points: When the number of points successfully evaluated exceeds this number, the task is terminated regardless of other criteria.
<li> Max number of evaluation jobs: An evaluation job might succeed or fail. A successful job is used to evaluate the next HP, so that the evaluation process won't have to spin up another job. If a job fails, another job is created to evaluate the current HP, until the maximum number of evaluation jobs is exceeded.
<li> Number of points per iteration: The number of HP points submitted to the evaluation process every iteration.
<li> Min number of unevaluated points: The next iteration is initiated when the number of unevaluated points falls below this number. The number of newly generated points is equal to (Number of points per iteration - Min number of unevaluated points). Thus, the min number of unevaluated points must be less that the number of points per iteration. 
<li> Evaluation input: The name of the file containing the HP point to evaluate generated by the steering process and provided to the evaluation process in the work folder. Your training script must recognize this file and read the HP point from it.
<li> Evaluation output: The file containing the loss value to be picked up by the evaluation process and handed to the steering process. Your training script must write a json file with this exact name containing the loss value.
<li> Evaluation metrics: The name of metrics file produced by evaluation.
<li> Output dataset name: A custom name for the output dataset containing all log files and output files from evaluation, downloadable from rucio. This custom name will be concatenated as follows 'user.{YOUR USERNAME}.{CUSTOM NAME}.{UID}' for identification.
<li> Training dataset: If you store your training data on rucio, provide the dataset name here.
<li> Search algorithm: The algorithm that the steering process uses to generate new HP points from the loss value at evaluated points.
<li> Grid sites: The grid site at which the task is run.
<li> Evaluation container (<b>required</b>): The docker container used for evaluation. We created this container in step 4 of this document. 
<li> Evaluation command (<b>required</b>): A command to initiate the training. To make this part less error-prone, I recommend writing a bash script to setup the environment and a single command to run this script rather than inputting a multiline command in this section. The bash script might be packaged in your evaluation container or uploaded along with your task during submision. 
</ul>

<p> After making changes, click on Save to confirm your configurations. 

<li> Verifying and submitting your task

<p> After filling and saving the task configuration, click on the Next button or the Review tab, where you can see a summary of your task, including the search space and the configurations. </p>

![Review screen](images/review.png)

<p> Once you are happy with the task, click on the verify task button. HPOGUI will perform a few final checks and ask you to modify your task where necessary. If everything goes well, it will present you with the Submit button to submit your task, as follows.

![submit](images/submit.png)

If the task is successfully submitted, a dialogue appears with the JEDI task ID. You can monitor the task by going to [bigPANDA](https://bigpanda.cern.ch/) and log in to your account.


<li> Saving your search space and configuration files

You have the option to download the search space and configuration files. The next time you submit a similar task, you can upload these files to HPOGUI, and it will automatically configure your search space and task configurations for you. Simply click on the Download button at the end of you review page to save them. 

When configuring your next task, you can upload these files in the "File upload" tab, along with any addition files you might want to use when running your task. 

![Upload](images/upload.png)

</ol>


<!-- You can whip up these ingredients in any manner. Typically, you can provide two json files each containing one of these elements. However, unless you type them according to an exact format, your task is likely to break. I have created an online tool to aid with this process. I will show you how to use it in this document. Let us start with the search space. -->
